Package ec

# Class BreedingSource

java.lang.Object
ec.BreedingSource

All Implemented Interfaces:
  `Prototype`, `Setup`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

Direct Known Subclasses:
  `BreedingPipeline`, `SelectionMethod`

public abstract class BreedingSource extends Object implements Prototype, RandomChoiceChooserD
A BreedingSource is a Prototype which provides Individuals to populate new populations based on old ones. The BreedingSource/BreedingPipeline/SelectionMethod mechanism is inherently designed to work within single subpopulations, which is by far the most common case. If for some reason you need to breed among different subpopulations to produce new ones in a manner that can't be handled with exchanges, you will probably have to write your own custom Breeder; you'd have to write your own custom breeding pipelines anyway of course, though you can probably get away with reusing the SelectionMethods.

A BreedingSource may have parent sources which feed it as well. Some BreedingSources, SelectionMethods, are meant solely to plug into other BreedingSources, BreedingPipelines. BreedingPipelines can plug into other BreedingPipelines, and can also be used to provide the final Individual meant to populate a new generation.

Think of BreedingSources as Streams of Individuals; at one end of the stream is the provider, a SelectionMethod, which picks individuals from the old population. At the other end of the stream is a BreedingPipeline which hands you the finished product, a small set of new Individuals for you to use in populating your new population.

Parameters

base`.prob` 0.0 <= double <= 1.0, or undefined | (probability this BreedingSource gets chosen. Undefined is only valid if the caller of this BreedingSource doesn't need a probability)

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final double`
  `NO_PROBABILITY`
  `static final String`
  `P_PROB`
  `double`
  `probability`
  The probability that this BreedingSource will be chosen to breed over other BreedingSources.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BreedingSource()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `void`
  `fillStubs(EvolutionState state, BreedingSource source)`
  `abstract void`
  `finishProducing(EvolutionState state, int subpopulation, int thread)`
  Called after produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution (at the end of the run).
  `final double`
  `getProbability(Object obj)`
  Returns obj's probability
  `static int`
  `pickRandom(BreedingSource[] sources, double prob)`
  Picks a random source from an array of sources, with their probabilities normalized and summed as follows: For example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.
  `void`
  `preparePipeline(Object hook)`
  A hook which should be passed to all your subsidiary breeding sources.
  `abstract void`
  `prepareToProduce(EvolutionState state, int subpopulation, int thread)`
  Called before produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution, to let the breeding source "warm up" prior to producing.
  `abstract int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `abstract boolean`
  `produces(EvolutionState state, Population newpop, int subpopulation, int thread)`
  Returns true if this BreedingSource, when attached to the given subpopulation, will produce individuals of the subpopulation's species.
  `final void`
  `setProbability(Object obj, double prob)`
  Sets obj's probability
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `static void`
  `setupProbabilities(BreedingSource[] sources)`
  Normalizes and arranges the probabilities in sources so that they are usable by pickRandom(...).
  `abstract int`
  `typicalIndsProduced()`
  Returns the "typical" number of individuals generated with one call of produce(...).

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface ec.Prototype

  `defaultBase`

- ## Field Details

  - ### P_PROB

    public static final String P_PROB
    See Also:
      - Constant Field Values

  - ### NO_PROBABILITY

    public static final double NO_PROBABILITY
    See Also:
      - Constant Field Values

  - ### probability

    public double probability
    The probability that this BreedingSource will be chosen to breed over other BreedingSources. This may or may not be used, depending on what the caller to this BreedingSource is. It also might be modified by external sources owning this object, for their own purposes. A BreedingSource should not use it for any purpose of its own, nor modify it except when setting it up.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

- ## Constructor Details

  - ### BreedingSource

    public BreedingSource()

- ## Method Details

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### getProbability

    public final double getProbability(Object obj)
    Description copied from interface: `RandomChoiceChooserD`
    Returns obj's probability
    Specified by:
      `getProbability` in interface `RandomChoiceChooserD`

  - ### setProbability

    public final void setProbability(Object obj, double prob)
    Description copied from interface: `RandomChoiceChooserD`
    Sets obj's probability
    Specified by:
      `setProbability` in interface `RandomChoiceChooserD`

  - ### pickRandom

    public static int pickRandom(BreedingSource[] sources, double prob)
    Picks a random source from an array of sources, with their probabilities normalized and summed as follows: For example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

  - ### setupProbabilities

    public static void setupProbabilities(BreedingSource[] sources)
    Normalizes and arranges the probabilities in sources so that they are usable by pickRandom(...). If the sources have all zero probabilities, then a uniform selection is used. Negative probabilities will generate an ArithmeticException, as will an empty source array.

  - ### typicalIndsProduced

    public abstract int typicalIndsProduced()
    Returns the "typical" number of individuals generated with one call of produce(...).

  - ### produces

    public abstract boolean produces(EvolutionState state, Population newpop, int subpopulation, int thread)
    Returns true if this BreedingSource, when attached to the given subpopulation, will produce individuals of the subpopulation's species. SelectionMethods should additionally make sure that their Fitnesses are of a valid type, if necessary. newpop *may* be the same as state.population

  - ### prepareToProduce

    public abstract void prepareToProduce(EvolutionState state, int subpopulation, int thread)
    Called before produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution, to let the breeding source "warm up" prior to producing. Individuals should be produced from old individuals in positions [start...start+length] in the subpopulation only. May be called again to reset the BreedingSource for a whole 'nuther subpopulation.

  - ### finishProducing

    public abstract void finishProducing(EvolutionState state, int subpopulation, int thread)
    Called after produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution (at the end of the run).

  - ### produce

    public abstract int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `Object`

  - ### fillStubs

    public void fillStubs(EvolutionState state, BreedingSource source)

  - ### preparePipeline

    public void preparePipeline(Object hook)
    A hook which should be passed to all your subsidiary breeding sources. The default does this for you already, so ordinarily you don't need to change anything. If you are a BreedingPipeline and you implement your sources in a way different than using the sources[] array, be sure to override this method so that it calls preparePipeline(hook) on all of your sources.

    ECJ at present does not custom-implement or call this method: it's available for you. Becuase it has custom functionality, this method might get called more than once, and by various objects as needed. If you use it, you should determine somehow how to use it to send information under the assumption that it might be sent by nested items in the pipeline; you don't want to scribble over each other's calls! Note that this method should travel *all* breeding source paths regardless of whether or not it's redundant to do so.